/* $Id: interface.h 9 2006-07-07 09:45:23Z cedric $ */

#ifndef INTER_H
#define INTER_H

#include <curses.h>
#include <panel.h>
#include <menu.h>

#define ARRAY_SIZE(a) (sizeof(a) / sizeof(a[0]))

#define ENTER 10
#define ESCAPE 27

#define NBRPANELS 5

typedef struct _PANEL_DATA {
	int hide;       /* TRUE if panel is hidden */
}PANEL_DATA;

/*
typedef struct _swin {
	WINDOW	*win;
	PANEL	*pan;
	PANEL_DATA panel_data;
	char * title;
	int start;
	int end;
	int hide;
	int max_display;
	int print_width;
	int col_start;
	int scrl_pos;
}swin;
*/

/* Global Variables */
WINDOW *topbar,*messagebar,*bgmenu;
WINDOW *act_wins[NBRPANELS];
ITEM **bg_items;
MENU *bg_menu;
PANEL  *act_panels[NBRPANELS];
PANEL_DATA panel_datas[NBRPANELS];
PANEL_DATA *temp;
int cur_scrl_pos; /* Hack before using swin */

void InitCurses();
void clearWin(WINDOW *bar);
void printStaticText(WINDOW *bar,char *text[],int size);
void printCenter(WINDOW *bar, int row, char *message);
void drawTopBar(WINDOW *topbar);
void drawMessageBar(WINDOW *bar,char *msg);
void drawHelpPanel(WINDOW *bar);
void drawConfirmPanel(WINDOW *bar);
void drawInfosPanel(WINDOW *bar,char *item);
void drawContactsPanel(WINDOW *bar,char *item,int sdeb);
void drawMessagesPanel(WINDOW *bar,char *item,int sdeb);

void CreateUsrMenu();
void DeleteUsrMenu();
void RefreshUsrMenu();
void CreateBars();
void DeleteBars();
void CreatePanels();
void CreatePanel(int id, int rows, int cols);
void DeletePanels();
void RefreshMsg();
int isHidden(PANEL *pan);
void HidePanels();
void HidePanel(PANEL *pan);
void ShowPanel(PANEL *pan);
void CursesLoop();
#endif //INTER_H
