/* $Id: lpcap.h 9 2006-07-07 09:45:23Z cedric $ */

#ifndef LPCAP_H
#define LPCAP_H

#define _BSD_SOURCE 1
#define SIZE_ETHERNET 14

struct ether_header {
        u_char ether_dhost[6]; //destination host (adresse de destination)
        u_char ether_shost[6]; //source host (adresse source)
        u_short ether_type;    //type de trame
};

struct ip {
#if BYTE_ORDER == LITTLE_ENDIAN   // l'ordre des bits dpendant des systmes
        u_char  ip_hl:4;          // header length (taille)
        u_char  ip_v:4;           // version
#endif
#if BYTE_ORDER == BIG_ENDIAN
        u_char  ip_v:4;           // version
        u_char  ip_hl:4;          // header length
#endif
        u_char  ip_tos;           // Type de service
        short   ip_len;           // taille totale
        u_short ip_id;            // identification
        short   ip_off;           // champ de dcalage du fragment
#define IP_DF 0x4000              // drapeau de non fragmentation
#define IP_MF 0x2000              // drapeau de fragmentation
#define IP_OFFMASK 0x1fff         // masque pour la fragmentation
        u_char  ip_ttl;           // time to live
        u_char  ip_p;             // protocole
        u_short ip_sum;           // somme de controle
        struct in_addr ip_src;    // adresse source
        struct in_addr ip_dest;   // adresse destination
};

#define IP_HL(ip)               (((ip)->ip_hl) & 0x0f)
#define IP_V(ip)                (((ip)->ip_hl) >> 4)

/* TCP header */
typedef u_int tcp_seq;

struct tcp {
        u_short th_sport;       /* source port */
        u_short th_dport;       /* destination port */
        tcp_seq th_seq;         /* sequence number */
        tcp_seq th_ack;         /* acknowledgement number */

        u_char th_offx2;        /* data offset, rsvd */
#define TH_OFF(th)      (((th)->th_offx2 & 0xf0) >> 4)
        u_char th_flags;
#define TH_FIN 0x01
#define TH_SYN 0x02
#define TH_RST 0x04
#define TH_PUSH 0x08
#define TH_ACK 0x10
#define TH_URG 0x20
#define TH_ECE 0x40
#define TH_CWR 0x80
#define TH_FLAGS (TH_FIN|TH_SYN|TH_RST|TH_ACK|TH_URG|TH_ECE|TH_CWR)
        u_short th_win;         /* window */
        u_short th_sum;         /* checksum */
        u_short th_urp;         /* urgent pointer */
};
#endif // LPCAP_H
